"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.zipLeft = exports.tap = exports.bind = void 0;
var _Function = require("effect/Function");
/**
 * @since 0.24.0
 */

/**
 * Sequences the specified effect after this effect, but ignores the value
 * produced by the effect.
 *
 * @category combining
 * @since 0.24.0
 */
const zipLeft = F => (0, _Function.dual)(2, (self, that) => tap(F)(self, () => that));
/**
 * Returns an effect that effectfully "peeks" at the success of this effect.
 *
 * @since 0.24.0
 */
exports.zipLeft = zipLeft;
const tap = F => (0, _Function.dual)(2, (self, f) => F.flatMap(self, a => F.map(f(a), () => a)));
/**
 * @category do notation
 * @since 0.24.0
 */
exports.tap = tap;
const bind = F => (0, _Function.dual)(3, (self, name, f) => F.flatMap(self, a => F.map(f(a), b => Object.assign({}, a, {
  [name]: b
}))));
exports.bind = bind;
//# sourceMappingURL=Chainable.js.map