"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.zipRight = exports.flatten = exports.composeK = void 0;
var _Function = require("effect/Function");
/**
 * @since 0.24.0
 */

/**
 * @since 0.24.0
 */
const flatten = F => self => F.flatMap(self, _Function.identity);
/**
 * A variant of `flatMap` that ignores the value produced by this effect.
 *
 * @since 0.24.0
 */
exports.flatten = flatten;
const zipRight = F => (0, _Function.dual)(2, (self, that) => F.flatMap(self, () => that));
/**
 * @since 0.24.0
 */
exports.zipRight = zipRight;
const composeK = F => (0, _Function.dual)(2, (afb, bfc) => a => F.flatMap(afb(a), bfc));
exports.composeK = composeK;
//# sourceMappingURL=FlatMap.js.map