"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SemigroupSum = exports.SemigroupMin = exports.SemigroupMax = exports.MonoidSum = exports.MonoidMin = exports.MonoidMax = exports.Bounded = void 0;
var Duration = _interopRequireWildcard(require("effect/Duration"));
var monoid = _interopRequireWildcard(require("../Monoid.js"));
var semigroup = _interopRequireWildcard(require("../Semigroup.js"));
function _interopRequireWildcard(e, t) { if ("function" == typeof WeakMap) var r = new WeakMap(), n = new WeakMap(); return (_interopRequireWildcard = function (e, t) { if (!t && e && e.__esModule) return e; var o, i, f = { __proto__: null, default: e }; if (null === e || "object" != typeof e && "function" != typeof e) return f; if (o = t ? n : r) { if (o.has(e)) return o.get(e); o.set(e, f); } for (const t in e) "default" !== t && {}.hasOwnProperty.call(e, t) && ((i = (o = Object.defineProperty) && Object.getOwnPropertyDescriptor(e, t)) && (i.get || i.set) ? o(f, t, i) : f[t] = e[t]); return f; })(e, t); }
/**
 * @since 0.24.0
 */

/**
 * @category instances
 * @since 0.24.0
 */
const Bounded = exports.Bounded = {
  compare: Duration.Order,
  maxBound: Duration.infinity,
  minBound: Duration.zero
};
/**
 * @category instances
 * @since 0.24.0
 */
const SemigroupSum = exports.SemigroupSum = /*#__PURE__*/semigroup.make(Duration.sum);
/**
 * @category instances
 * @since 0.24.0
 */
const MonoidSum = exports.MonoidSum = /*#__PURE__*/monoid.fromSemigroup(SemigroupSum, Duration.zero);
/**
 * @category instances
 * @since 0.24.0
 */
const SemigroupMax = exports.SemigroupMax = /*#__PURE__*/semigroup.make(Duration.max);
/**
 * @category instances
 * @since 0.24.0
 */
const MonoidMax = exports.MonoidMax = /*#__PURE__*/monoid.fromSemigroup(SemigroupMax, Duration.zero);
/**
 * @category instances
 * @since 0.24.0
 */
const SemigroupMin = exports.SemigroupMin = /*#__PURE__*/semigroup.make(Duration.min);
/**
 * @category instances
 * @since 0.24.0
 */
const MonoidMin = exports.MonoidMin = /*#__PURE__*/monoid.fromSemigroup(SemigroupMin, Duration.infinity);
//# sourceMappingURL=Duration.js.map