/**
 * @since 0.24.0
 */
import * as Either from "effect/Either";
import type * as applicative from "../Applicative.js";
import type * as bicovariant from "../Bicovariant.js";
import type * as chainable from "../Chainable.js";
import * as covariant from "../Covariant.js";
import type * as flatMap_ from "../FlatMap.js";
import type * as foldable from "../Foldable.js";
import type * as invariant from "../Invariant.js";
import type * as monad from "../Monad.js";
import type * as of_ from "../Of.js";
import type * as pointed from "../Pointed.js";
import type * as product_ from "../Product.js";
import type * as semiAlternative from "../SemiAlternative.js";
import type * as semiApplicative from "../SemiApplicative.js";
import type * as semiCoproduct from "../SemiCoproduct.js";
import type * as semiProduct from "../SemiProduct.js";
import type * as traversable from "../Traversable.js";
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Bicovariant: bicovariant.Bicovariant<Either.EitherTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Covariant: covariant.Covariant<Either.EitherTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Invariant: invariant.Invariant<Either.EitherTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Of: of_.Of<Either.EitherTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Pointed: pointed.Pointed<Either.EitherTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const FlatMap: flatMap_.FlatMap<Either.EitherTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Chainable: chainable.Chainable<Either.EitherTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Monad: monad.Monad<Either.EitherTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const SemiProduct: semiProduct.SemiProduct<Either.EitherTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Product: product_.Product<Either.EitherTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const SemiApplicative: semiApplicative.SemiApplicative<Either.EitherTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Applicative: applicative.Applicative<Either.EitherTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const SemiCoproduct: semiCoproduct.SemiCoproduct<Either.EitherTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const SemiAlternative: semiAlternative.SemiAlternative<Either.EitherTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Foldable: foldable.Foldable<Either.EitherTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Traversable: traversable.Traversable<Either.EitherTypeLambda>;
//# sourceMappingURL=Either.d.ts.map