/**
 * @since 0.24.40
 */
import * as Micro from "effect/Micro";
import type { Concurrency } from "effect/Types";
import type * as applicative from "../Applicative.js";
import type * as chainable from "../Chainable.js";
import * as covariant from "../Covariant.js";
import type * as flatMap_ from "../FlatMap.js";
import type * as invariant from "../Invariant.js";
import type * as monad from "../Monad.js";
import type * as of_ from "../Of.js";
import type * as pointed from "../Pointed.js";
import type * as product_ from "../Product.js";
import type * as semiApplicative from "../SemiApplicative.js";
import type * as semiProduct from "../SemiProduct.js";
/**
 * @category instances
 * @since 0.24.40
 */
export type ConcurrencyOptions = {
    readonly concurrency?: Concurrency | undefined;
};
/**
 * @category instances
 * @since 0.24.40
 */
export declare const Covariant: covariant.Covariant<Micro.MicroTypeLambda>;
/**
 * @category instances
 * @since 0.24.40
 */
export declare const Invariant: invariant.Invariant<Micro.MicroTypeLambda>;
/**
 * @category instances
 * @since 0.24.40
 */
export declare const Of: of_.Of<Micro.MicroTypeLambda>;
/**
 * @category instances
 * @since 0.24.40
 */
export declare const Pointed: pointed.Pointed<Micro.MicroTypeLambda>;
/**
 * @category instances
 * @since 0.24.40
 */
export declare const FlatMap: flatMap_.FlatMap<Micro.MicroTypeLambda>;
/**
 * @category instances
 * @since 0.24.40
 */
export declare const Chainable: chainable.Chainable<Micro.MicroTypeLambda>;
/**
 * @category instances
 * @since 0.24.40
 */
export declare const Monad: monad.Monad<Micro.MicroTypeLambda>;
/**
 * @category instances
 * @since 0.24.40
 */
export declare const getSemiProduct: (options?: ConcurrencyOptions) => semiProduct.SemiProduct<Micro.MicroTypeLambda>;
/**
 * @category instances
 * @since 0.24.40
 */
export declare const getProduct: (options?: ConcurrencyOptions) => product_.Product<Micro.MicroTypeLambda>;
/**
 * @category instances
 * @since 0.24.40
 */
export declare const getSemiApplicative: (options?: ConcurrencyOptions) => semiApplicative.SemiApplicative<Micro.MicroTypeLambda>;
/**
 * @category instances
 * @since 0.24.40
 */
export declare const getApplicative: (options?: ConcurrencyOptions) => applicative.Applicative<Micro.MicroTypeLambda>;
//# sourceMappingURL=Micro.d.ts.map