import * as Option from "effect/Option";
import type * as alternative from "../Alternative.js";
import type * as applicative from "../Applicative.js";
import type * as chainable from "../Chainable.js";
import type * as coproduct_ from "../Coproduct.js";
import * as covariant from "../Covariant.js";
import type * as filterable from "../Filterable.js";
import type * as flatMap_ from "../FlatMap.js";
import type * as foldable from "../Foldable.js";
import type * as invariant from "../Invariant.js";
import type * as monad from "../Monad.js";
import type { Monoid } from "../Monoid.js";
import type * as of_ from "../Of.js";
import type * as pointed from "../Pointed.js";
import type * as product_ from "../Product.js";
import type * as semiAlternative from "../SemiAlternative.js";
import type * as semiApplicative from "../SemiApplicative.js";
import type * as semiCoproduct from "../SemiCoproduct.js";
import type { Semigroup } from "../Semigroup.js";
import type * as semiProduct from "../SemiProduct.js";
import type * as traversable from "../Traversable.js";
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Covariant: covariant.Covariant<Option.OptionTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Invariant: invariant.Invariant<Option.OptionTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Of: of_.Of<Option.OptionTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Pointed: pointed.Pointed<Option.OptionTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const FlatMap: flatMap_.FlatMap<Option.OptionTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Chainable: chainable.Chainable<Option.OptionTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Monad: monad.Monad<Option.OptionTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const SemiProduct: semiProduct.SemiProduct<Option.OptionTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Product: product_.Product<Option.OptionTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const SemiApplicative: semiApplicative.SemiApplicative<Option.OptionTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Applicative: applicative.Applicative<Option.OptionTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const SemiCoproduct: semiCoproduct.SemiCoproduct<Option.OptionTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Coproduct: coproduct_.Coproduct<Option.OptionTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const SemiAlternative: semiAlternative.SemiAlternative<Option.OptionTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Alternative: alternative.Alternative<Option.OptionTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Foldable: foldable.Foldable<Option.OptionTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Filterable: filterable.Filterable<Option.OptionTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const Traversable: traversable.Traversable<Option.OptionTypeLambda>;
/**
 * @category instances
 * @since 0.24.0
 */
export declare const getOptionalMonoid: <A>(Semigroup: Semigroup<A>) => Monoid<Option.Option<A>>;
//# sourceMappingURL=Option.d.ts.map