/**
 * @since 0.24.0
 */
import { dual } from "effect/Function";
/**
 * Composing two contravariant functors yields a Covariant functor.
 *
 * Returns a default binary `map` composition.
 *
 * @since 0.24.0
 */
export const contramapComposition = (F, G) => (self, f) => F.contramap(self, G.contramap(f));
/**
 * Returns a default `imap` implementation.
 *
 * @since 0.24.0
 */
export const imap = contramap => dual(3, (self, _, from) => contramap(self, from));
//# sourceMappingURL=Contravariant.js.map