/**
 * @since 0.24.0
 */
import { dual, identity } from "effect/Function";
/**
 * @since 0.24.0
 */
export const flatten = F => self => F.flatMap(self, identity);
/**
 * A variant of `flatMap` that ignores the value produced by this effect.
 *
 * @since 0.24.0
 */
export const zipRight = F => dual(2, (self, that) => F.flatMap(self, () => that));
/**
 * @since 0.24.0
 */
export const composeK = F => dual(2, (afb, bfc) => a => F.flatMap(afb(a), bfc));
//# sourceMappingURL=FlatMap.js.map