/**
 * @since 0.24.0
 */
import { dual, identity } from "effect/Function";
/**
 * Returns a default ternary `reduce` composition.
 *
 * @since 0.24.0
 */
export const reduceComposition = (F, G) => (self, b, f) => F.reduce(self, b, (b, ga) => G.reduce(ga, b, f));
/**
 * @since 0.24.0
 */
export const toArrayMap = F => dual(2, (self, f) => F.reduce(self, [], (out, a) => [...out, f(a)]));
/**
 * @since 0.24.0
 */
export const toArray = F => toArrayMap(F)(identity);
/**
 * @since 0.24.0
 */
export const combineMap = F => M => dual(2, (self, f) => F.reduce(self, M.empty, (m, a) => M.combine(m, f(a))));
/**
 * @since 0.24.0
 */
export const reduceKind = F => G => dual(3, (self, b, f) => F.reduce(self, G.of(b), (gb, a) => G.flatMap(gb, b => f(b, a))));
/**
 * @since 0.24.0
 */
export const coproductMapKind = F => G => dual(2, (self, f) => F.reduce(self, G.zero(), (gb, a) => G.coproduct(gb, f(a))));
//# sourceMappingURL=Foldable.js.map