/**
 * @since 0.24.0
 */
import * as Duration from "effect/Duration";
import * as monoid from "../Monoid.js";
import * as semigroup from "../Semigroup.js";
/**
 * @category instances
 * @since 0.24.0
 */
export const Bounded = {
  compare: Duration.Order,
  maxBound: Duration.infinity,
  minBound: Duration.zero
};
/**
 * @category instances
 * @since 0.24.0
 */
export const SemigroupSum = /*#__PURE__*/semigroup.make(Duration.sum);
/**
 * @category instances
 * @since 0.24.0
 */
export const MonoidSum = /*#__PURE__*/monoid.fromSemigroup(SemigroupSum, Duration.zero);
/**
 * @category instances
 * @since 0.24.0
 */
export const SemigroupMax = /*#__PURE__*/semigroup.make(Duration.max);
/**
 * @category instances
 * @since 0.24.0
 */
export const MonoidMax = /*#__PURE__*/monoid.fromSemigroup(SemigroupMax, Duration.zero);
/**
 * @category instances
 * @since 0.24.0
 */
export const SemigroupMin = /*#__PURE__*/semigroup.make(Duration.min);
/**
 * @category instances
 * @since 0.24.0
 */
export const MonoidMin = /*#__PURE__*/monoid.fromSemigroup(SemigroupMin, Duration.infinity);
//# sourceMappingURL=Duration.js.map