/**
 * @since 0.24.0
 */
import * as monoid from "../Monoid.js";
import * as semigroup from "../Semigroup.js";
/**
 * `string` semigroup under concatenation.
 *
 * @category instances
 * @since 0.24.0
 */
export const Semigroup = /*#__PURE__*/semigroup.make((self, that) => self + that);
/**
 * `string` monoid under concatenation.
 *
 * The `empty` value is `''`.
 *
 * @category instances
 * @since 0.24.0
 */
export const Monoid = /*#__PURE__*/monoid.fromSemigroup(Semigroup, "");
//# sourceMappingURL=String.js.map